#include "chip.h"
#include <math.h>
#include <stdlib.h>
#include "lbitfield.h"
/* ----------------- SYSPLL --------------------------------------------------*/
#if CHIP_CLK_SYSPLLIN_EN
    #if !CHIP_CLK_SYSPLLIN_SRC_EN
        #error SYSPLL input clock source is not enabled
    #endif

    #if CHIP_CLK_SYSPLL_SRC_ID == CHIP_CLK_IRC_ID
        #define CHIP_RVAL_SYSPLLCLKSEL  CHIP_REGFLDVAL_SYSCON_SYSPLLCLKSEL_SEL_IRC
    #elif CHIP_CLK_SYSPLL_SRC_ID == CHIP_CLK_SYSOSC_ID
        #define CHIP_RVAL_SYSPLLCLKSEL  CHIP_REGFLDVAL_SYSCON_SYSPLLCLKSEL_SEL_SYSOSC
    #elif CHIP_CLK_SYSPLL_SRC_ID == CHIP_CLK_RTCOSC_ID
        #define CHIP_RVAL_SYSPLLCLKSEL  CHIP_REGFLDVAL_SYSCON_SYSPLLCLKSEL_SEL_RTCOSC
        #if CHIP_CLK_SYSPLL_EN
            #error SYSPLL cannot be used with RTCOSC input clock
        #endif
    #else
        #error Invalid PLL clock source
    #endif
#endif

#if CHIP_CLK_SYSPLL_EN
    #if (CHIP_CLK_SYSPLLIN_FREQ < CHIP_CLK_PLL_IN_FREQ_MIN) || (CHIP_CLK_SYSPLLIN_FREQ > CHIP_CLK_PLL_IN_FREQ_MAX)
        #error SYSPLL input frequency is out of range
    #endif

    #if ((CHIP_CLK_SYSPLL_MUL >= 1) && (CHIP_CLK_SYSPLL_MUL <= 32))
        #define CHIP_RVAL_SYSPLLCTRL_M      (CHIP_CLK_SYSPLL_MUL - 1)
    #else
        #error "Invalid SYSPLL multiplier value"
    #endif

    #if CHIP_CLK_SYSPLL_FREQ > CHIP_CLK_PLL_OUT_FREQ_MAX
        #error "SYSPLL output frequency is out of range"
    #elif CHIP_CLK_SYSPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/4
        #define CHIP_RVAL_SYSPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_SYSPLLCTRL_PSEL_2
    #elif CHIP_CLK_SYSPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/8
        #define CHIP_RVAL_SYSPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_SYSPLLCTRL_PSEL_4
    #elif CHIP_CLK_SYSPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/16
        #define CHIP_RVAL_SYSPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_SYSPLLCTRL_PSEL_8
    #else
        #error "SYSPLL FCCO frequency is out of range"
    #endif
#endif


/* -------------- USB CLOCK --------------------------------------------------*/
#if CHIP_CLK_USB_SETUP_EN
    #if !CHIP_CLK_USBPLLIN_EN
        #error USBPLL input clock source is not enabled
    #endif

    #if CHIP_CLK_USBPLL_SRC_ID == CHIP_CLK_IRC_ID
        #define CHIP_RVAL_USBPLLCLKSEL  CHIP_REGFLDVAL_SYSCON_USBPLLCLKSEL_SEL_IRC
    #elif CHIP_CLK_USBPLL_SRC_ID == CHIP_CLK_SYSOSC_ID
        #define CHIP_RVAL_USBPLLCLKSEL  CHIP_REGFLDVAL_SYSCON_USBPLLCLKSEL_SEL_SYSOSC
    #else
        #error Invalid USBPLL clock source
    #endif

    #if (CHIP_CLK_USBPLLIN_FREQ < CHIP_CLK_PLL_IN_FREQ_MIN) || (CHIP_CLK_USBPLLIN_FREQ > CHIP_CLK_PLL_IN_FREQ_MAX)
        #error USBPLL input frequency is out of range
    #endif

    #if ((CHIP_CLK_USBPLL_MUL >= 1) && (CHIP_CLK_USBPLL_MUL <= 32))
        #define CHIP_RVAL_USBPLLCTRL_M      (CHIP_CLK_USBPLL_MUL - 1)
    #else
        #error "Invalid USBPLL multiplier value"
    #endif

    #if CHIP_CLK_USBPLL_FREQ > CHIP_CLK_PLL_OUT_FREQ_MAX
        #error "USBPLL output frequency is out of range"
    #elif CHIP_CLK_USBPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/4
        #define CHIP_RVAL_USBPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_USBPLLCTRL_PSEL_2
    #elif CHIP_CLK_USBPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/8
        #define CHIP_RVAL_USBPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_USBPLLCTRL_PSEL_4
    #elif CHIP_CLK_USBPLL_FREQ > CHIP_CLK_PLL_VCO_FREQ_MIN/16
        #define CHIP_RVAL_USBPLLCTRL_P  CHIP_REGFLDVAL_SYSCON_USBPLLCTRL_PSEL_8
    #else
        #error "USBPLL FCCO frequency is out of range"
    #endif

    #if !CHIP_CLK_USBIN_EN
        #error USB input clock source is not enabled
    #endif

    #if CHIP_CLK_USB_SRC_ID == CHIP_CLK_USBPLL_ID
        #define CHIP_RVAL_USBCLKSEL     CHIP_REGFLDVAL_SYSCON_USBCLKSEL_SEL_USBPLL
    #elif CHIP_CLK_USB_SRC_ID == CHIP_CLK_MAIN_ID
        #define CHIP_RVAL_USBCLKSEL     CHIP_REGFLDVAL_SYSCON_USBCLKSEL_SEL_MAINCLK
    #else
        #error Invalid USBPLL clock source
    #endif

    #if (CHIP_CLK_USB_DIV < 1) || (CHIP_CLK_USB_DIV > 255)
        #error Invalid USB CLK Divider value
    #endif

    #if CHIP_CLK_USB_FREQ != CHIP_MHZ(48)
        #error Invalid USB clock frequency
    #endif
#endif


/* --------------------------- MAINCLK ---------------------------------------*/
#if !CHIP_CLK_MAIN_EN
    #error MAINCLK clock source is not enabled
#endif

#if CHIP_CLK_MAIN_SRC_ID == CHIP_CLK_IRC_ID
    #define CHIP_RVAL_MAINCLKSEL        CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_IRC
#elif CHIP_CLK_MAIN_SRC_ID == CHIP_CLK_SYSPLLIN_ID
    #define CHIP_RVAL_MAINCLKSEL        CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_PLL_IN
#elif CHIP_CLK_MAIN_SRC_ID == CHIP_CLK_WDTOSC_ID
    #define CHIP_RVAL_MAINCLKSEL        CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_WDT
#elif CHIP_CLK_MAIN_SRC_ID == CHIP_CLK_SYSPLL_ID
    #define CHIP_RVAL_MAINCLKSEL        CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_PLL
#else
    #error Invalid MAINCLK clock source
#endif

#if (CHIP_CLK_SYS_DIV < 1) || (CHIP_CLK_SYS_DIV > 255)
    #error Invalid SYSCLK Divider value
#endif

#if (CHIP_CLK_USART0_DIV < 0) || (CHIP_CLK_USART0_DIV > 255)
    #error Invalid USART0 clock divider value
#endif

#if (CHIP_CLK_SSP0_DIV < 0) || (CHIP_CLK_SSP0_DIV > 255)
    #error Invalid SSP0 clock divider value
#endif

#if (CHIP_CLK_SSP1_DIV < 0) || (CHIP_CLK_SSP1_DIV > 255)
    #error Invalid SSP1 clock divider value
#endif

#if (CHIP_CLK_FRG_DIV < 0) || (CHIP_CLK_FRG_DIV > 255)
    #error Invalid FRG clock divider value
#endif

#if (CHIP_CLK_FRG_FRACT_MUL < 0) || (CHIP_CLK_FRG_FRACT_MUL > 255)
    #error Invalid FRG fractional multiplier value
#endif



/* -------------------------- CLKOUT -----------------------------------------*/
#if CHIP_CLK_CLKOUT_EN
#if CHIP_CLK_CLKOUT_SRC_ID == CHIP_CLK_IRC_ID
    #define CHIP_RVAL_CLKOUTSEL         CHIP_REGFLDVAL_SYSCON_CLKOUTSEL_SEL_IRC
#elif CHIP_CLK_CLKOUT_SRC_ID == CHIP_CLK_SYSOSC_ID
    #define CHIP_RVAL_CLKOUTSEL         CHIP_REGFLDVAL_SYSCON_CLKOUTSEL_SEL_SYSOSC
#elif CHIP_CLK_CLKOUT_SRC_ID == CHIP_CLK_WDTOSC_ID
    #define CHIP_RVAL_CLKOUTSEL         CHIP_REGFLDVAL_SYSCON_CLKOUTSEL_SEL_WDT
#elif CHIP_CLK_CLKOUT_SRC_ID == CHIP_CLK_MAIN_ID
    #define CHIP_RVAL_CLKOUTSEL         CHIP_REGFLDVAL_SYSCON_CLKOUTSEL_SEL_MAINCLK
#else
    #error Invlid CLKOUT clock source
#endif

#if !CHIP_CLK_CLKOUTSRC_EN
    #error CLKOUT freq source is not enabled
#endif

#if (CHIP_CLK_CLKOUT_DIV < 0) || (CHIP_CLK_CLKOUT_DIV > 255)
    #error invalid CLKOUT divider value
#endif
#endif

/* ----------------------------------- WDT -----------------------------------*/
#if CHIP_CLK_WDTOSC_SETUP_EN
    #if CHIP_CLK_WDTOSC_EN
    #if CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(600)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_0_6MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(1050)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_1_05MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(1400)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_1_4MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(1750)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_1_75MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(2100)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_2_1MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(2400)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_2_4MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(2700)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_2_7MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(3000)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_3_0MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(3250)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_3_25MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(3500)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_3_5MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(3750)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_3_75MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(4000)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_4_0MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(4200)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_4_2MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(4400)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_4_4MHZ
    #elif CHIP_CLK_WDTANA_FREQ == CHIP_KHZ(4600)
        #define CHIP_RVAL_WDTOSCSEL         CHIP_REGFLDVAL_SYSCON_WDTOSCCTRL_FREQSEL_4_6MHZ
    #else
        #error "invalid WDSOSC src freq"
    #endif


    #if (CHIP_CLK_WDTOSC_DIV < 2) || (CHIP_CLK_WDTOSC_DIV > 64) || (CHIP_CLK_WDTOSC_DIV % 2 != 0)
        #error invalid WDTOS freq division
    #else
        #define CHIP_RVAL_WDTOSCDIV         (CHIP_CLK_WDTOSC_DIV/2 - 1)
    #endif

    #endif

    #if CHIP_CLK_WDT_SRC_ID == CHIP_CLK_IRC_ID
        #define CHIP_RVAL_WDT_CLKSEL      CHIP_REGFLDVAL_WWDT_CLKSEL_VAL_IRC
    #elif CHIP_CLK_WDT_SRC_ID == CHIP_CLK_WDTOSC_ID
        #define CHIP_RVAL_WDT_CLKSEL      CHIP_REGFLDVAL_WWDT_CLKSEL_VAL_WDTOSC
    #else
        #error "invalid WDT src freq"
    #endif

    #if (CHIP_WDT_TIMEOUT_VAL < CHIP_WDT_TC_MAX_MIN) || (CHIP_WDT_TIMEOUT_VAL > CHIP_WDT_TC_MAX_VAL)
        #error invalid wtd tout value
    #endif

    #if (CHIP_WDT_WARNTIME_VAL < 0) || (CHIP_WDT_WARNTIME_VAL > CHIP_WDT_WARNTIME_MAX_VAL)
        #error invalid wtd warn  time value
    #endif

    #if (CHIP_WDT_WINDOW_VAL < 0) || (CHIP_WDT_WINDOW_VAL > CHIP_WDT_WINDOW_MAX_VAL)
        #error invalid wtd window time value
    #endif

    #if !CHIP_CLK_WDT_EN
        #error wdt clk freq source is not enabled
    #endif
#endif




void chip_clk_init(void) {
    /* изначально включаем IRC и переходим на IRC */
    if (LBITFIELD_GET(CHIP_REGS_SYSCON->MAINCLKSEL,CHIP_REGFLD_SYSCON_MAINCLKSEL_SEL) != CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_IRC) {
        CHIP_REGS_SYSCON->PDRUNCFG &= ~(CHIP_REGFLD_SYSCON_PDRUNCFG_IRC_PD | CHIP_REGFLD_SYSCON_PDRUNCFG_IRCOUT_PD);

        CHIP_REGS_SYSCON->MAINCLKSEL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKSEL_SEL, CHIP_REGFLDVAL_SYSCON_MAINCLKSEL_SEL_IRC);
        CHIP_REGS_SYSCON->MAINCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKUEN_ENA, 0);
        CHIP_REGS_SYSCON->MAINCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKUEN_ENA, 1);
        CHIP_REGS_SYSCON->SYSAHBCLKDIV = 1;
    }

#if CHIP_CLK_WDTOSC_SETUP_EN
#if CHIP_CLK_WDTOSC_EN
    CHIP_REGS_SYSCON->WDTOSCCTRL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_WDTOSCCTRL_DIVSEL, CHIP_RVAL_WDTOSCDIV)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_WDTOSCCTRL_FREQSEL, CHIP_RVAL_WDTOSCSEL);
    CHIP_REGS_SYSCON->PDRUNCFG &=  ~CHIP_REGFLD_SYSCON_PDRUNCFG_WDTOSC_PD;
#else
    CHIP_REGS_SYSCON->PDRUNCFG |=  CHIP_REGFLD_SYSCON_PDRUNCFG_WDTOSC_PD;
#endif
#endif


#if CHIP_WDT_SETUP_EN
    chip_per_clk_en(CHIP_PER_ID_WWDT);
    CHIP_REGS_WWDT->CLKSEL =  LBITFIELD_SET(CHIP_REGFLD_WWDT_CLKSEL_VAL, CHIP_RVAL_WDT_CLKSEL);
#if CHIP_WDT_CLK_LOCK
    CHIP_REGS_WWDT->CLKSEL |= CHIP_REGFLD_WWDT_CLKSEL_LOCK;
#endif

    CHIP_REGS_WWDT->TC = CHIP_WDT_TIMEOUT_VAL;
    CHIP_REGS_WWDT->MOD |=  CHIP_REGFLD_WWDT_MOD_WD_RESET | CHIP_REGFLD_WWDT_MOD_WD_INT | CHIP_REGFLD_WWDT_MOD_WD_EN;
#if CHIP_WDT_CLK_LOCK
    CHIP_REGS_WWDT->MOD |= CHIP_REGFLD_WWDT_MOD_LOCK;
#endif
    CHIP_REGS_WWDT->WINDOW = CHIP_WDT_WINDOW_VAL;
    CHIP_REGS_WWDT->WARNINT = CHIP_WDT_WARNTIME_VAL;

    chip_wdt_reset();

#if CHIP_WDT_TC_PROTECT
    chip_delay_clk(3*CHIP_CLK_WDT_FREQ/CHIP_CLK_IRC_FREQ);
    CHIP_REGS_WWDT->MOD |= CHIP_REGFLD_WWDT_MOD_WD_PROTECT;
#endif
#endif





    /* разрешение или запрет клока RTC 32 КГц */
    CHIP_REGS_SYSCON->RTCOSCCTRL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_RTCOSCCTRL_RTCOSCEN, CHIP_CLK_RTCOSC_EN);


    /* настройка SYSOSC */
#if CHIP_CLK_SYSOSC_EN
    CHIP_PIN_CONFIG(CHIP_PIN_P2_0_XTALIN);
#if CHIP_CLK_SYSOSC_MODE == CHIP_CLK_EXTMODE_OSC
    CHIP_PIN_CONFIG(CHIP_PIN_P2_1_XTALOUT);
#endif
    if (CHIP_REGS_SYSCON->PDRUNCFG & CHIP_REGFLD_SYSCON_PDRUNCFG_SYSOSC_PD) {
        CHIP_REGS_SYSCON->PDRUNCFG &= ~CHIP_REGFLD_SYSCON_PDRUNCFG_SYSOSC_PD;
        /* необходима задержка 500 мкс после включения питания OSC.
         * учитываем, что вначале всегда частота берется от IRC */
        chip_delay_clk(CHIP_CLK_CPU_INITIAL_FREQ/2000);
    }

    CHIP_REGS_SYSCON->SYSOSCCTRL =
            LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSOSCCTRL_BYPASS, CHIP_CLK_SYSOSC_MODE == CHIP_CLK_EXTMODE_CLOCK)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSOSCCTRL_FREQRANGE, CHIP_CLK_SYSOSC_FREQ > CHIP_MHZ(17));
#else
    CHIP_REGS_SYSCON->PDRUNCFG |= CHIP_REGFLD_SYSCON_PDRUNCFG_SYSOSC_PD;
#endif


    /* настройка PLL */
#if CHIP_CLK_SYSPLLIN_EN
    CHIP_REGS_SYSCON->SYSPLLCLKSEL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSPLLCLKSEL_SEL, CHIP_RVAL_SYSPLLCLKSEL);
    CHIP_REGS_SYSCON->SYSPLLCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSPLLCLKUEN_ENA, 0);
    CHIP_REGS_SYSCON->SYSPLLCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSPLLCLKUEN_ENA, 1);
#endif

#if CHIP_CLK_SYSPLL_EN
    CHIP_REGS_SYSCON->PDRUNCFG &= ~CHIP_REGFLD_SYSCON_PDRUNCFG_SYSPLL_PD;

    CHIP_REGS_SYSCON->SYSPLLCTRL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSPLLCTRL_MSEL, CHIP_RVAL_SYSPLLCTRL_M)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSPLLCTRL_PSEL, CHIP_RVAL_SYSPLLCTRL_P);

    while ((CHIP_REGS_SYSCON->SYSPLLSTAT & CHIP_REGFLD_SYSCON_SYSPLLSTAT_LOCK) == 0) {}
#else
    CHIP_REGS_SYSCON->PDRUNCFG |= CHIP_REGFLD_SYSCON_PDRUNCFG_SYSPLL_PD;
#endif

    /* настройка MAINCLK */
    CHIP_REGS_SYSCON->SYSAHBCLKDIV = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKDIV_DIV, CHIP_CLK_SYS_DIV);
    CHIP_REGS_SYSCON->MAINCLKSEL   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKSEL_SEL, CHIP_RVAL_MAINCLKSEL);
    CHIP_REGS_SYSCON->MAINCLKUEN   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKUEN_ENA, 0);
    CHIP_REGS_SYSCON->MAINCLKUEN   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_MAINCLKUEN_ENA, 1);


    /* -------------------------- настройка USB ------------------------------*/
#if CHIP_CLK_USB_SETUP_EN
    CHIP_REGS_SYSCON->PDRUNCFG &= ~CHIP_REGFLD_SYSCON_PDRUNCFG_USBPLL_PD;
    /* настройка USB PLL даже если USB будет работать от MAINCLK, т.к. по умолчанию
     * USB работает от USB PLL и для переключения обе частоты должны быть включены */
    CHIP_REGS_SYSCON->USBPLLCLKSEL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBPLLCLKSEL_SEL, CHIP_RVAL_USBPLLCLKSEL);
    CHIP_REGS_SYSCON->USBPLLCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBPLLCLKUEN_ENA, 0);
    CHIP_REGS_SYSCON->USBPLLCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBPLLCLKUEN_ENA, 1);

    CHIP_REGS_SYSCON->USBPLLCTRL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBPLLCTRL_MSEL, CHIP_RVAL_USBPLLCTRL_M)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBPLLCTRL_PSEL, CHIP_RVAL_USBPLLCTRL_P);
    while ((CHIP_REGS_SYSCON->USBPLLSTAT & CHIP_REGFLD_SYSCON_USBPLLSTAT_LOCK) == 0) {}


    CHIP_REGS_SYSCON->USBCLKSEL = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBCLKSEL_SEL, CHIP_RVAL_USBCLKSEL);
    CHIP_REGS_SYSCON->USBCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBCLKUEN_ENA, 0);
    CHIP_REGS_SYSCON->USBCLKUEN = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBCLKUEN_ENA, 1);
    CHIP_REGS_SYSCON->USBCLKDIV = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USBCLKDIV_DIV, CHIP_CLK_USB_DIV);
#endif

#if !CHIP_CLK_USBPLL_EN
    CHIP_REGS_SYSCON->PDRUNCFG |= CHIP_REGFLD_SYSCON_PDRUNCFG_USBPLL_PD;
#endif

    /* если IRC не требуется, отключение после смены настроек основного клока */
#if !CHIP_CLK_IRC_EN
    CHIP_REGS_SYSCON->PDRUNCFG |= CHIP_REGFLD_SYSCON_PDRUNCFG_IRC_PD | CHIP_REGFLD_SYSCON_PDRUNCFG_IRCOUT_PD;
#endif


#if CHIP_CLK_USART0_EN
    CHIP_REGS_SYSCON->USART0CLKDIV = LBITFIELD_SET(CHIP_REGFLD_SYSCON_USART0CLKDIV_DIV, CHIP_CLK_USART0_DIV);
#endif
#if CHIP_CLK_SSP0_EN
    CHIP_REGS_SYSCON->SSP0CLKDIV   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SSP0CLKDIV_DIV,   CHIP_CLK_SSP0_DIV);
#endif
#if CHIP_CLK_SSP1_EN
    CHIP_REGS_SYSCON->SSP1CLKDIV   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_SSP1CLKDIV_DIV,   CHIP_CLK_SSP1_DIV);
#endif
#if CHIP_CLK_FRG_EN
    CHIP_REGS_SYSCON->UARTFRGDIV   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_UARTFRGDIV_DIV,   0xFF); /* FRACTDIV поддерживает только значение 0xFF */
    CHIP_REGS_SYSCON->UARTFRGMULT  = LBITFIELD_SET(CHIP_REGFLD_SYSCON_UARTFRGMULT_MULT, CHIP_CLK_FRG_FRACT_MUL);
    CHIP_REGS_SYSCON->FRGCLKDIV    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_FRGCLKDIV_DIV,    CHIP_CLK_FRG_DIV);
#endif

#if CHIP_CLK_CLKOUT_EN
    CHIP_REGS_SYSCON->CLKOUTSEL    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_CLKOUTSEL_SEL, CHIP_RVAL_CLKOUTSEL);
    CHIP_REGS_SYSCON->CLKOUTUEN    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_CLKOUTUEN_ENA, 0);
    CHIP_REGS_SYSCON->CLKOUTUEN    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_CLKOUTUEN_ENA, 1);
    CHIP_REGS_SYSCON->CLKOUTDIV    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_CLKOUTDIV_DIV, CHIP_CLK_CLKOUT_DIV);
#if CHIP_CLK_CLKOUT_DIV != 0
    /* настраиваем пин на вывод частоты */
    CHIP_PIN_CONFIG(CHIP_PIN_P0_1_CLKOUT);
#endif
#else
    CHIP_REGS_SYSCON->CLKOUTDIV    = LBITFIELD_SET(CHIP_REGFLD_SYSCON_CLKOUTDIV_DIV, 0);
#endif


    CHIP_REGS_SYSCON->SYSAHBCLKCTRL = 0
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_SYS, 1)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_ROM,           CHIP_CLK_ROM_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_RAM0,          CHIP_CLK_SRAM0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_FLASHREG,      CHIP_CLK_FLASHREG_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_FLASHARRAY,    CHIP_CLK_FLASH_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_I2C0,          CHIP_CLK_I2C0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_GPIO,          CHIP_CLK_GPIO_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_CT16B0,        CHIP_CLK_CT16B0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_CT16B1,        CHIP_CLK_CT16B1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_CT32B0,        CHIP_CLK_CT32B0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_CT32B1,        CHIP_CLK_CT32B1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_SSP0,          CHIP_CLK_SSP0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USART0,        CHIP_CLK_USART0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_ADC,           CHIP_CLK_ADC_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USB,           CHIP_CLK_USB_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_WWDT,          CHIP_CLK_WWDT_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_IOCON,         CHIP_CLK_IOCON_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_SSP1,          CHIP_CLK_SSP1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_PINT,          CHIP_CLK_PINT_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USART1,        CHIP_CLK_USART1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USART2,        CHIP_CLK_USART2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USART3_4,      CHIP_CLK_USART3_4_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_GROUP0INT,     CHIP_CLK_GROUP0INT_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_GROUP1INT,     CHIP_CLK_GROUP1INT_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_I2C1,          CHIP_CLK_I2C1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_RAM1,          CHIP_CLK_SRAM1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_USBRAM,        CHIP_CLK_USBSRAM_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_CRC,           CHIP_CLK_CRC_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_DMA,           CHIP_CLK_DMA_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_RTC,           CHIP_CLK_RTC_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_SYSAHBCLKCTRL_SCT0_1,        CHIP_CLK_SCT0_1_EN)
            ;

    /* снимаем сброс с периферии, которое разрешена при старте */
    CHIP_REGS_SYSCON->PRESETCTRL = 0
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_SSP0_RSTN,      CHIP_CLK_SSP0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_I2C0_RSTN,      CHIP_CLK_I2C0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_SSP1_RSTN,      CHIP_CLK_SSP1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_I2C1_RSTN,      CHIP_CLK_I2C1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_FRG_RSTN,       CHIP_CLK_FRG_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_USART1_RSTN,    CHIP_CLK_USART1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_USART2_RSTN,    CHIP_CLK_USART2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_USART3_RSTN,    CHIP_CLK_USART3_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_USART4_RSTN,    CHIP_CLK_USART4_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_SCT0_RSTN,      CHIP_CLK_SCT0_EN)
            | LBITFIELD_SET(CHIP_REGFLD_SYSCON_PRESETCTRL_SCT1_RSTN,      CHIP_CLK_SCT1_EN)
            ;
}


#if CHIP_CLK_FRG_DIV > 0

static inline int bishift_left(int val, int q) {
    return (q < 0) ? (val >>  -q) : (val <<  q);
}
static inline int bishift_right(int val, int q) {
    return (q < 0) ? (val <<  -q) : (val >>  q);
}

void chip_frg_configure(unsigned uart_baud_rate, unsigned *uart_brgdiv, unsigned *uart_res_freq) {
    int base_q = -8;
    unsigned i;
    uint32_t best_err = 0xFFFFFFFF;
    uint16_t fdm;
    const uint16_t fda = 256;
    uint32_t base;
    const unsigned inclk = CHIP_CLK_FRGIN_FREQ;
    unsigned fract_div = 0;
    unsigned fract_mul = 1;

    for (i=0; i < 17; i++) {
        if (inclk & (1UL << (31-i)))
            break;
        base_q++;
    }


    *uart_brgdiv = 1;

    base = bishift_left(inclk, base_q);
    base_q += 4;
    uart_baud_rate = bishift_left(uart_baud_rate, base_q);

    for (fdm = 0; fdm <= 255; fdm++) {
        uint32_t err;
        uint32_t f = base * fda / (uint32_t)(fdm + fda);
        uint32_t udl = (f + uart_baud_rate / 2) / uart_baud_rate;
        if (udl > 0xFFFF)
            continue;
        long uart_f = (long)(f / udl);
        err = (uint32_t)labs(uart_f - (long)uart_baud_rate);
        if (err < best_err) {
            best_err = err;
            fract_div = fda;
            fract_mul = fdm;
            *uart_brgdiv = udl;
            if (uart_res_freq) {
                *uart_res_freq = bishift_right(uart_f, base_q);
            }
        }
    }

    chip_per_clk_en(CHIP_PER_ID_FRG);
    CHIP_REGS_SYSCON->UARTFRGDIV   = LBITFIELD_SET(CHIP_REGFLD_SYSCON_UARTFRGDIV_DIV,   fract_div - 1);
    CHIP_REGS_SYSCON->UARTFRGMULT  = LBITFIELD_SET(CHIP_REGFLD_SYSCON_UARTFRGMULT_MULT, fract_mul);
}
#endif
